> For the complete documentation index, see [llms.txt](https://docs.tradevest.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tradevest.ai/api-reference/asset-management/corporate-actions.md).

# Corporate Actions

## Get Corporate Actions

> Get Corporate Actions

```json
{"openapi":"3.0.1","info":{"title":"CorporateActions","version":"1.0"},"tags":[{"name":"Corporate Actions","description":"Corporate Actions"}],"servers":[{"url":"https://tvda-api.platform-test.tradevest.ai","description":"Test"},{"url":"https://tvda-api.platform-pretest.tradevest.ai","description":"Pretest"}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"oauth2","flows":{"clientCredentials":{"tokenUrl":"/oauth2/token","refreshUrl":"","scopes":{}}}}},"schemas":{"CorporateActions":{"title":"Corporate Actions","type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/CorporateAction"}},"pagination":{"$ref":"#/components/schemas/Pagination"}},"required":["data","pagination"]},"CorporateAction":{"title":"CorporateAction","type":"object","properties":{"corporateActionId":{"type":"string","format":"uuid"},"corporateActionEventType":{"$ref":"#/components/schemas/CorporateActionEventTypeEnum"},"isin":{"type":"string"},"status":{"$ref":"#/components/schemas/CorporateActionStatusEnum"},"dates":{"$ref":"#/components/schemas/CorporateActionDates"},"details":{"$ref":"#/components/schemas/CorporateActionDetails"},"customer":{"$ref":"#/components/schemas/CorporateActionCustomer"},"corporateActionReference":{"type":"string","description":"Reference number linking related MT564 (announcement) and MT566 (settlement) events for the same corporate action"}},"required":["corporateActionId","corporateActionEventType","isin","status","dates","details","customer"]},"CorporateActionEventTypeEnum":{"title":"CorporateActionEventTypeEnum","type":"string","description":"Corporate action event type","enum":["DVCA","INTR","REDM","BONU","SPLF","TEND","CHDV","EXRI","MEET","DVOP","LIQU","DVSE"]},"CorporateActionStatusEnum":{"title":"CorporateActionStatusEnum","type":"string","description":"Corporate action event status","enum":["ANNOUNCED","PENDING","SETTLED","REJECTED"]},"CorporateActionDates":{"title":"CorporateActionDates","type":"object","properties":{"exDate":{"type":"string","format":"date-time"},"paymentDate":{"type":"string","format":"date-time"},"effectiveDate":{"type":"string","format":"date-time"},"recordDate":{"type":"string","format":"date-time"},"responseDeadline":{"type":"string","format":"date-time"},"createdOn":{"type":"string","format":"date-time"},"modifiedOn":{"type":"string","format":"date-time"}},"required":["paymentDate","recordDate","exDate","createdOn","modifiedOn"]},"CorporateActionDetails":{"title":"CorporateActionDetails","type":"object","properties":{"ratioFrom":{"type":"number","format":"decimal","description":"Ratio From for SPLF/BONU corporate actions"},"grossAmountPerShare":{"type":"number"},"ratioTo":{"type":"number","format":"decimal","description":"Ratio To for SPLF/BONU corporate actions."},"quantitySuccessfullyTendered":{"type":"number","format":"decimal","description":"Quantity of shares successfully tendered for TEND corporate action."},"corporateActionOptions":{"$ref":"#/components/schemas/CorporateActionTenderOptions"}}},"CorporateActionTenderOptions":{"type":"array","items":{"$ref":"#/components/schemas/CorporateActionTenderOption"}},"CorporateActionTenderOption":{"type":"object","required":["tenderOption"],"properties":{"tenderOption":{"$ref":"#/components/schemas/CorporateActionOptionEnum"},"isDefaultAction":{"type":"boolean","description":"Is Default Action"},"offeredPricePerShare":{"type":"number","format":"decimal","description":"Offered Price Per Share"},"maximumCashAmount":{"type":"number","format":"decimal","description":"Maximum cash amount for CASH options"},"maximumQuantitySharesAccepted":{"type":"number","format":"decimal","description":"Maximum Quantity of Shares Accepted"},"creditedIsin":{"type":"string","description":"ISIN of credited securities for STOCK options"},"exchangeRatio":{"type":"number","format":"decimal","description":"Exchange ratio for STOCK options"}}},"CorporateActionOptionEnum":{"title":"CorporateActionOptionEnum","type":"string","description":"Tender Option","enum":["NONE","CASH","STOCK"]},"CorporateActionCustomer":{"title":"CorporateActionCustomer","type":"object","properties":{"customerId":{"type":"string","format":"uuid"},"customerProductId":{"type":"string","format":"uuid"},"corporateActionCustomerId":{"type":"string","format":"uuid"},"eligibleQuantity":{"type":"number"},"oldQuantity":{"type":"number"},"newQuantity":{"type":"number"},"ratioFrom":{"type":"number"},"ratioTo":{"type":"number"},"grossAmount":{"type":"number"},"netAmount":{"type":"number"},"submittedCorporateActionOptions":{"$ref":"#/components/schemas/SubmittedCorporateActionTenderOptions"},"currency":{"$ref":"#/components/schemas/CurrencyEnum"},"createdOn":{"type":"string","format":"date-time"},"modifiedOn":{"type":"string","format":"date-time"}},"required":["customerId","customerProductId","corporateActionCustomerId","eligibleQuantity","createdOn","modifiedOn","currency"]},"SubmittedCorporateActionTenderOptions":{"type":"array","items":{"$ref":"#/components/schemas/SubmittedActionTenderOption"}},"SubmittedActionTenderOption":{"type":"object","required":["tenderOption"],"properties":{"tenderOption":{"$ref":"#/components/schemas/CorporateActionOptionEnum"},"submittedTenderQuantity":{"type":"number","format":"decimal","description":"Submitted Tender Quantity"},"quantitySuccessfullyTendered":{"type":"number","format":"decimal","description":"Quantity successfully tendered after tender offer (TEND)"},"tenderedCashAmount":{"type":"number","format":"decimal","description":"Tendered cash amount after tender offer (TEND)"}}},"CurrencyEnum":{"title":"CurrencyEnum","type":"string","description":"Currency of the product's balance. Currency code in ISO 4217","enum":["EUR"]},"Pagination":{"title":"Pagination","type":"object","properties":{"cursor":{"type":"string","description":"String value used for pagination, which should be set in next page request."},"limit":{"type":"integer","description":"Maximum number of returned items"}},"required":["cursor","limit"]},"ErrorMessage":{"title":"ErrorMessage","type":"object","properties":{"message":{"type":"string"},"responseType":{"type":"string"},"validationString":{"minLength":1,"type":"string"},"requestId":{"type":"string"},"errorCode":{"type":"string","maxLength":255},"errorDetails":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"}}},"required":["message","responseType","requestId"]},"ErrorDetails":{"title":"ErrorDetails","type":"object","properties":{"field":{"type":"string","maxLength":255},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetailsExplanation"}}},"required":["field"]},"ErrorDetailsExplanation":{"title":"ErrorDetailsExplanation","type":"object","properties":{"code":{"type":"string","maxLength":255},"parameter":{"type":"string"},"message":{"type":"string"}},"required":["code","message"]}}},"paths":{"/corporate-actions/":{"get":{"summary":"Get Corporate Actions","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CorporateActions"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}},"operationId":"get-corporate-actions","description":"Get Corporate Actions","tags":["Corporate Actions"],"parameters":[{"schema":{"type":"string"},"in":"query","name":"cursor","description":"String value used for pagination"},{"schema":{"type":"integer","minimum":1,"default":20},"in":"query","name":"limit","description":"Maximum number of items to return"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"startCreatedOn","description":"Display corporate actions created on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"endCreatedOn","description":"Display corporate actions created on or before this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"exDate","description":"Display corporate actions with ex-date on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"paymentDate","description":"Display corporate actions with payment date on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"recordDate","description":"Display corporate actions with record date on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"responseDeadline","description":"Display corporate actions with response deadline on or after this date"},{"schema":{"$ref":"#/components/schemas/CorporateActionStatusEnum"},"in":"query","name":"status","description":"Display corporate actions with this status"},{"schema":{"type":"string"},"in":"query","name":"corporateActionReference","description":"Display corporate actions with this reference number (links MT564 and MT566 events for the same underlying action)"}]}}}}
```

## Submit customer option for corporate action

> The endpoint is currently under development, and the structure may still change.

```json
{"openapi":"3.0.1","info":{"title":"CorporateActions","version":"1.0"},"tags":[{"name":"Corporate Actions","description":"Corporate Actions"}],"servers":[{"url":"https://tvda-api.platform-test.tradevest.ai","description":"Test"},{"url":"https://tvda-api.platform-pretest.tradevest.ai","description":"Pretest"}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"oauth2","flows":{"clientCredentials":{"tokenUrl":"/oauth2/token","refreshUrl":"","scopes":{}}}}},"schemas":{"SubmitCustomerCorporateActionOptionRequest":{"title":"SubmitCustomerCorporateActionOptionRequest","type":"object","properties":{"depositoryCustomerProductId":{"type":"string","format":"uuid","description":"The identifier of the depository customer product instance"},"elections":{"type":"array","items":{"type":"object","properties":{"corporateActionOption":{"$ref":"#/components/schemas/CorporateActionOptionEnum"},"tenderedQuantity":{"type":"number","multipleOf":1,"minimum":1,"description":"Number of shares to be tendered for the corporate action option."}},"required":["corporateActionOption","tenderedQuantity"]}}},"required":["depositoryCustomerProductId","elections"]},"CorporateActionOptionEnum":{"title":"CorporateActionOptionEnum","type":"string","description":"Tender Option","enum":["NONE","CASH","STOCK"]},"ErrorMessage":{"title":"ErrorMessage","type":"object","properties":{"message":{"type":"string"},"responseType":{"type":"string"},"validationString":{"minLength":1,"type":"string"},"requestId":{"type":"string"},"errorCode":{"type":"string","maxLength":255},"errorDetails":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"}}},"required":["message","responseType","requestId"]},"ErrorDetails":{"title":"ErrorDetails","type":"object","properties":{"field":{"type":"string","maxLength":255},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetailsExplanation"}}},"required":["field"]},"ErrorDetailsExplanation":{"title":"ErrorDetailsExplanation","type":"object","properties":{"code":{"type":"string","maxLength":255},"parameter":{"type":"string"},"message":{"type":"string"}},"required":["code","message"]}}},"paths":{"/corporate-actions/{corporateActionId}/instructions":{"post":{"summary":"Submit customer option for corporate action","description":"The endpoint is currently under development, and the structure may still change.","operationId":"submit-customer-corporate-action-option","tags":["Corporate Actions"],"parameters":[{"schema":{"type":"string","format":"uuid"},"name":"corporateActionId","in":"path","required":true,"description":"Id of corporate action"},{"schema":{"type":"string","format":"uuid"},"name":"Requestor-ID","in":"header","required":true,"description":"Unique requestor identification in UUID format"}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/SubmitCustomerCorporateActionOptionRequest"}}}},"responses":{"202":{"description":"Accepted","content":{}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}},"404":{"description":"Not Found","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}}}}}}
```

## Get Corporate Actions by Customer

> Get Corporate Actions by Customer

```json
{"openapi":"3.0.1","info":{"title":"CorporateActions","version":"1.0"},"tags":[{"name":"Corporate Actions","description":"Corporate Actions"}],"servers":[{"url":"https://tvda-api.platform-test.tradevest.ai","description":"Test"},{"url":"https://tvda-api.platform-pretest.tradevest.ai","description":"Pretest"}],"security":[{"Bearer":[]}],"components":{"securitySchemes":{"Bearer":{"type":"oauth2","flows":{"clientCredentials":{"tokenUrl":"/oauth2/token","refreshUrl":"","scopes":{}}}}},"schemas":{"CorporateActions":{"title":"Corporate Actions","type":"object","properties":{"data":{"type":"array","items":{"$ref":"#/components/schemas/CorporateAction"}},"pagination":{"$ref":"#/components/schemas/Pagination"}},"required":["data","pagination"]},"CorporateAction":{"title":"CorporateAction","type":"object","properties":{"corporateActionId":{"type":"string","format":"uuid"},"corporateActionEventType":{"$ref":"#/components/schemas/CorporateActionEventTypeEnum"},"isin":{"type":"string"},"status":{"$ref":"#/components/schemas/CorporateActionStatusEnum"},"dates":{"$ref":"#/components/schemas/CorporateActionDates"},"details":{"$ref":"#/components/schemas/CorporateActionDetails"},"customer":{"$ref":"#/components/schemas/CorporateActionCustomer"},"corporateActionReference":{"type":"string","description":"Reference number linking related MT564 (announcement) and MT566 (settlement) events for the same corporate action"}},"required":["corporateActionId","corporateActionEventType","isin","status","dates","details","customer"]},"CorporateActionEventTypeEnum":{"title":"CorporateActionEventTypeEnum","type":"string","description":"Corporate action event type","enum":["DVCA","INTR","REDM","BONU","SPLF","TEND","CHDV","EXRI","MEET","DVOP","LIQU","DVSE"]},"CorporateActionStatusEnum":{"title":"CorporateActionStatusEnum","type":"string","description":"Corporate action event status","enum":["ANNOUNCED","PENDING","SETTLED","REJECTED"]},"CorporateActionDates":{"title":"CorporateActionDates","type":"object","properties":{"exDate":{"type":"string","format":"date-time"},"paymentDate":{"type":"string","format":"date-time"},"effectiveDate":{"type":"string","format":"date-time"},"recordDate":{"type":"string","format":"date-time"},"responseDeadline":{"type":"string","format":"date-time"},"createdOn":{"type":"string","format":"date-time"},"modifiedOn":{"type":"string","format":"date-time"}},"required":["paymentDate","recordDate","exDate","createdOn","modifiedOn"]},"CorporateActionDetails":{"title":"CorporateActionDetails","type":"object","properties":{"ratioFrom":{"type":"number","format":"decimal","description":"Ratio From for SPLF/BONU corporate actions"},"grossAmountPerShare":{"type":"number"},"ratioTo":{"type":"number","format":"decimal","description":"Ratio To for SPLF/BONU corporate actions."},"quantitySuccessfullyTendered":{"type":"number","format":"decimal","description":"Quantity of shares successfully tendered for TEND corporate action."},"corporateActionOptions":{"$ref":"#/components/schemas/CorporateActionTenderOptions"}}},"CorporateActionTenderOptions":{"type":"array","items":{"$ref":"#/components/schemas/CorporateActionTenderOption"}},"CorporateActionTenderOption":{"type":"object","required":["tenderOption"],"properties":{"tenderOption":{"$ref":"#/components/schemas/CorporateActionOptionEnum"},"isDefaultAction":{"type":"boolean","description":"Is Default Action"},"offeredPricePerShare":{"type":"number","format":"decimal","description":"Offered Price Per Share"},"maximumCashAmount":{"type":"number","format":"decimal","description":"Maximum cash amount for CASH options"},"maximumQuantitySharesAccepted":{"type":"number","format":"decimal","description":"Maximum Quantity of Shares Accepted"},"creditedIsin":{"type":"string","description":"ISIN of credited securities for STOCK options"},"exchangeRatio":{"type":"number","format":"decimal","description":"Exchange ratio for STOCK options"}}},"CorporateActionOptionEnum":{"title":"CorporateActionOptionEnum","type":"string","description":"Tender Option","enum":["NONE","CASH","STOCK"]},"CorporateActionCustomer":{"title":"CorporateActionCustomer","type":"object","properties":{"customerId":{"type":"string","format":"uuid"},"customerProductId":{"type":"string","format":"uuid"},"corporateActionCustomerId":{"type":"string","format":"uuid"},"eligibleQuantity":{"type":"number"},"oldQuantity":{"type":"number"},"newQuantity":{"type":"number"},"ratioFrom":{"type":"number"},"ratioTo":{"type":"number"},"grossAmount":{"type":"number"},"netAmount":{"type":"number"},"submittedCorporateActionOptions":{"$ref":"#/components/schemas/SubmittedCorporateActionTenderOptions"},"currency":{"$ref":"#/components/schemas/CurrencyEnum"},"createdOn":{"type":"string","format":"date-time"},"modifiedOn":{"type":"string","format":"date-time"}},"required":["customerId","customerProductId","corporateActionCustomerId","eligibleQuantity","createdOn","modifiedOn","currency"]},"SubmittedCorporateActionTenderOptions":{"type":"array","items":{"$ref":"#/components/schemas/SubmittedActionTenderOption"}},"SubmittedActionTenderOption":{"type":"object","required":["tenderOption"],"properties":{"tenderOption":{"$ref":"#/components/schemas/CorporateActionOptionEnum"},"submittedTenderQuantity":{"type":"number","format":"decimal","description":"Submitted Tender Quantity"},"quantitySuccessfullyTendered":{"type":"number","format":"decimal","description":"Quantity successfully tendered after tender offer (TEND)"},"tenderedCashAmount":{"type":"number","format":"decimal","description":"Tendered cash amount after tender offer (TEND)"}}},"CurrencyEnum":{"title":"CurrencyEnum","type":"string","description":"Currency of the product's balance. Currency code in ISO 4217","enum":["EUR"]},"Pagination":{"title":"Pagination","type":"object","properties":{"cursor":{"type":"string","description":"String value used for pagination, which should be set in next page request."},"limit":{"type":"integer","description":"Maximum number of returned items"}},"required":["cursor","limit"]},"ErrorMessage":{"title":"ErrorMessage","type":"object","properties":{"message":{"type":"string"},"responseType":{"type":"string"},"validationString":{"minLength":1,"type":"string"},"requestId":{"type":"string"},"errorCode":{"type":"string","maxLength":255},"errorDetails":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetails"}}},"required":["message","responseType","requestId"]},"ErrorDetails":{"title":"ErrorDetails","type":"object","properties":{"field":{"type":"string","maxLength":255},"errors":{"type":"array","items":{"$ref":"#/components/schemas/ErrorDetailsExplanation"}}},"required":["field"]},"ErrorDetailsExplanation":{"title":"ErrorDetailsExplanation","type":"object","properties":{"code":{"type":"string","maxLength":255},"parameter":{"type":"string"},"message":{"type":"string"}},"required":["code","message"]}}},"paths":{"/corporate-actions/customers/{customerId}":{"get":{"summary":"Get Corporate Actions by Customer","responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CorporateActions"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorMessage"}}}}},"operationId":"get-corporate-actions-by-customer-id","description":"Get Corporate Actions by Customer","tags":["Corporate Actions"],"parameters":[{"schema":{"type":"string"},"in":"query","name":"cursor","description":"String value used for pagination"},{"schema":{"type":"integer","minimum":1,"default":20},"in":"query","name":"limit","description":"Maximum number of items to return"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"startCreatedOn","description":"Display corporate actions created on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"endCreatedOn","description":"Display corporate actions created on or before this date"},{"schema":{"type":"string"},"in":"query","name":"corporateActionReference","description":"Display corporate actions with this reference number (links MT564 and MT566 events for the same underlying action)"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"exDate","description":"Display corporate actions with ex-date on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"paymentDate","description":"Display corporate actions with payment date on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"recordDate","description":"Display corporate actions with record date on or after this date"},{"schema":{"type":"string","format":"date-time"},"in":"query","name":"responseDeadline","description":"Display corporate actions with response deadline on or after this date"},{"schema":{"$ref":"#/components/schemas/CorporateActionStatusEnum"},"in":"query","name":"status","description":"Display corporate actions with this status"}]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tradevest.ai/api-reference/asset-management/corporate-actions.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
